OGRE: Ogre::BillboardChain Class Reference

| OGRE 14.5 Object-Oriented Graphics Rendering Engine

Loading...
Searching...
No Matches
Ogre::BillboardChain Class Reference
Core » Effects

Allows the rendering of a chain of connected billboards. More...

`#include <OgreBillboardChain.h>`

Inheritance diagram for Ogre::BillboardChain:
[legend]

## Classes
class | Element
| Contains the data of an element of the BillboardChain. More...

## Public Types
enum | TexCoordDirection { TCD_U , TCD_V }
| The direction in which texture coordinates from elements of the chain are used. More...
Public Types inherited from Ogre::ShadowCaster
typedef Ogre::ShadowRenderableList | ShadowRenderableList
typedef VectorIterator< ShadowRenderableList > | ShadowRenderableListIterator
Public Types inherited from Ogre::Renderable
enum | { DEFAULT_PRIORITY = 100 }

## Public Member Functions
| BillboardChain (const String &name, size_t maxElements=20, size_t numberOfChains=1, bool useTextureCoords=true, bool useColours=true, bool dynamic=true)
| Constructor (don't use directly, use factory).
| ~BillboardChain ()
void | _updateRenderQueue (RenderQueue *) override
| Internal method by which the movable object must add Renderable subclass instances to the rendering queue.
virtual void | addChainElement (size_t chainIndex, const Element &billboardChainElement)
| Add an element to the 'head' of a chain.
virtual void | clearAllChains (void)
| Remove all elements from all chains (but leave the chains themselves intact).
virtual void | clearChain (size_t chainIndex)
| Remove all elements of a given chain (but leave the chain intact).
bool | getAutoUpdate (void) const
| Return the auto update state.
const AxisAlignedBox & | getBoundingBox (void) const override
| Retrieves the local axis-aligned bounding box for this object.
Real | getBoundingRadius (void) const override
| Retrieves the radius of the origin-centered bounding sphere for this object.
virtual const Element & | getChainElement (size_t chainIndex, size_t elementIndex) const
| Get the detail of a chain element.
const LightList & | getLights (void) const override
| Gets a list of lights, ordered relative to how close they are to this renderable.
const MaterialPtr & | getMaterial (void) const override
| Retrieves a weak reference to the material this renderable object uses.
virtual const String & | getMaterialName (void) const
| Get the material name in use.
virtual size_t | getMaxChainElements (void) const
| Get the maximum number of chain elements per chain.
const String & | getMovableType (void) const override
| Returns the type name of this object.
virtual size_t | getNumberOfChains (void) const
| Get the number of chain segments (this class can render multiple chains at once using the same material).
virtual size_t | getNumChainElements (size_t chainIndex) const
| Returns the number of chain elements.
virtual const Real * | getOtherTextureCoordRange (void) const
| Get the range of the texture coordinates generated across the width of the chain elements.
void | getRenderOperation (RenderOperation &) override
| Gets the render operation required to send this object to the frame buffer.
Real | getSquaredViewDepth (const Camera *cam) const override
| Returns the squared distance between the camera and this renderable.
virtual TexCoordDirection | getTextureCoordDirection (void)
| Gets the direction in which texture coords specified on each element are deemed to run.
virtual bool | getUseTextureCoords (void) const
| Gets whether texture coordinate information should be included in the final buffers generated.
virtual bool | getUseVertexColours (void) const
| Gets whether vertex colour information should be included in the final buffers generated.
void | getWorldTransforms (Matrix4 *) const override
| Gets the world transform matrix / matrices for this renderable object.
bool | preRender (SceneManager *sm, RenderSystem *rsys) override
| Called just prior to the Renderable being rendered.
virtual void | removeChainElement (size_t chainIndex)
| Remove an element from the 'tail' of a chain.
void | setAutoUpdate (bool autoUpdate)
| Set the auto update state.
void | setFaceCamera (bool faceCamera, const Vector3 &normalVector=Vector3::UNIT_X)
| Sets whether the billboard should always be facing the camera or a custom direction set by each point element.
virtual void | setMaterialName (const String &name, const String &groupName=ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME)
| Set the material name to use for rendering.
virtual void | setMaxChainElements (size_t maxElements)
| Set the maximum number of chain elements per chain.
virtual void | setNumberOfChains (size_t numChains)
| Set the number of chain segments (this class can render multiple chains at once using the same material).
virtual void | setOtherTextureCoordRange (Real start, Real end)
| Set the range of the texture coordinates generated across the width of the chain elements.
virtual void | setTextureCoordDirection (TexCoordDirection dir)
| Sets the direction in which texture coords specified on each element are deemed to run along the length of the chain.
virtual void | setUseTextureCoords (bool use)
| Sets whether texture coordinate information should be included in the final buffers generated.
virtual void | setUseVertexColours (bool use)
| Sets whether vertex colour information should be included in the final buffers generated.
virtual void | updateChainElement (size_t chainIndex, size_t elementIndex, const Element &billboardChainElement)
| Update the details of an existing chain element.
void | visitRenderables (Renderable::Visitor *visitor, bool debugRenderables=false) override
| Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.
Public Member Functions inherited from Ogre::MovableObject
| MovableObject ()
| Constructor.
| MovableObject (const String &name)
| Named constructor.
virtual | ~MovableObject ()
| Virtual destructor - read Scott Meyers if you don't know why this is needed.
MovableObjectFactory * | _getCreator (void) const
| Get the creator of this object, if any (internal use only).
LightList * | _getLightList ()
| Returns a pointer to the current list of lights for this object.
SceneManager * | _getManager (void) const
| Get the manager of this object, if any (internal use only).
virtual const Affine3 & | _getParentNodeFullTransform (void) const
| Return the full transformation of the parent sceneNode or the attachingPoint node.
virtual void | _notifyAttached (Node *parent, bool isTagPoint=false)
| Internal method called to notify the object that it has been attached to a node.
virtual void | _notifyCreator (MovableObjectFactory *fact)
| Notify the object of it's creator (internal use only).
virtual void | _notifyCurrentCamera (Camera *cam)
| Internal method to notify the object of the camera to be used for the next rendering operation.
virtual void | _notifyManager (SceneManager *man)
| Notify the object of it's manager (internal use only).
virtual void | _notifyMoved (void)
| Internal method called to notify the object that it has been moved.
virtual void | _releaseManualHardwareResources ()
| Notifies the movable object that hardware resources were lost.
virtual void | _restoreManualHardwareResources ()
| Notifies the movable object that hardware resources should be restored.
void | addQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | addVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are appended to the existing flags on this object.
void | detachFromParent (void)
| Detaches an object from a parent SceneNode or TagPoint, if attached.
Real | getBoundingRadiusScaled () const
| as getBoundingRadius, but with scaling applied
bool | getCastShadows (void) const override
| Returns whether shadow casting is enabled for this object.
uint32 | getLightMask () const
| Get a bitwise mask which will filter the lights affecting this object.
Listener * | getListener (void) const
| Gets the current listener for this object.
const String & | getName (void) const
| Returns the name of this object.
Node * | getParentNode (void) const
| Returns the node to which this object is attached.
SceneNode * | getParentSceneNode (void) const
| Returns the scene node to which this object is attached.
Real | getPointExtrusionDistance (const Light *l) const override
| Get the distance to extrude for a point/spot light.
virtual uint32 | getQueryFlags (void) const
| Returns the query flags relevant for this object.
bool | getReceivesShadows ()
| Returns whether the Material of any Renderable that this MovableObject will add to the render queue will receive shadows.
Real | getRenderingDistance (void) const
| Gets the distance at which batches are no longer rendered.
Real | getRenderingMinPixelSize () const
| Returns the minimum pixel size an object needs to be in both screen axes in order to be rendered.
uint8 | getRenderQueueGroup (void) const
| Gets the queue group for this entity.
virtual uint32 | getTypeFlags (void) const
| Get the 'type flags' for this MovableObject.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
virtual uint32 | getVisibilityFlags (void) const
| Returns the visibility flags relevant for this object.
bool | getVisible (void) const
| Gets this object whether to be visible or not, if it has a renderable component.
const AxisAlignedBox & | getWorldBoundingBox (bool derive=false) const override
| Retrieves the axis-aligned bounding box for this object in world coordinates.
virtual const Sphere & | getWorldBoundingSphere (bool derive=false) const
| Retrieves the worldspace bounding sphere for this object.
bool | isAttached (void) const
| Returns true if this object is attached to a SceneNode or TagPoint.
bool | isDebugDisplayEnabled (void) const
| Gets whether debug display of this object is enabled.
virtual bool | isInScene (void) const
| Returns true if this object is attached to a SceneNode or TagPoint, and this SceneNode / TagPoint is currently in an active part of the scene graph.
bool | isParentTagPoint () const
| Gets whether the parent node is a TagPoint (or a SceneNode).
virtual bool | isVisible (void) const
| Returns whether or not this object is supposed to be visible or not.
const LightList & | queryLights (void) const
| Gets a list of lights, ordered relative to how close they are to this movable object.
void | removeQueryFlags (uint32 flags)
| As setQueryFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | removeVisibilityFlags (uint32 flags)
| As setVisibilityFlags, except the flags passed as parameters are removed from the existing flags on this object.
void | setCastShadows (bool enabled)
| Sets whether or not this object will cast shadows.
void | setDebugDisplayEnabled (bool enabled)
| Sets whether or not the debug display of this object is enabled.
void | setLightMask (uint32 lightMask)
| Set a bitwise mask which will filter the lights affecting this object.
void | setListener (Listener *listener)
| Sets a listener for this object.
void | setQueryFlags (uint32 flags)
| Sets the query flags for this object.
void | setRenderingDistance (Real dist)
| Sets the distance at which the object is no longer rendered.
void | setRenderingMinPixelSize (Real pixelSize)
| Sets the minimum pixel size an object needs to be in both screen axes in order to be rendered.
virtual void | setRenderQueueGroup (uint8 queueID)
| Sets the render queue group this entity will be rendered through.
virtual void | setRenderQueueGroupAndPriority (uint8 queueID, ushort priority)
| Sets the render queue group and group priority this entity will be rendered through.
void | setUserAny (const Any &anything)
void | setVisibilityFlags (uint32 flags)
| Sets the visibility flags for this object.
void | setVisible (bool visible)
| Tells this object whether to be visible or not, if it has a renderable component.
Public Member Functions inherited from Ogre::ShadowCaster
virtual | ~ShadowCaster ()
const AxisAlignedBox & | getDarkCapBounds (const Light &light, Real dirLightExtrusionDist) const
| Gets the world space bounding box of the dark cap, as extruded using the light provided.
virtual EdgeData * | getEdgeList (void)
| Returns details of the edges which might be used to determine a silhouette.
const AxisAlignedBox & | getLightCapBounds (void) const
| Gets the world space bounding box of the light cap.
virtual const ShadowRenderableList & | getShadowVolumeRenderableList (const Light *light, const HardwareIndexBufferPtr &indexBuffer, size_t &indexBufferUsedSize, float extrusionDistance, int flags=0)
| Gets an list of the renderables required to render the shadow volume.
bool | hasEdgeList ()
| Returns whether the object has a valid edge list.
Public Member Functions inherited from Ogre::AnimableObject
| AnimableObject ()
virtual | ~AnimableObject ()
virtual AnimableValuePtr | createAnimableValue (const String &valueName)
| Create a reference-counted AnimableValuePtr for the named value.
virtual const StringVector & | getAnimableValueNames (void) const
| Gets a list of animable value names for this object.
Public Member Functions inherited from Ogre::Renderable
| Renderable ()
virtual | ~Renderable ()
| Virtual destructor needed as class has virtual methods.
uint16 | _getMaterialLodIndex () const
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
const Vector4f & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual uint16 | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
const Any & | getUserAny (void) const
UserObjectBindings & | getUserObjectBindings ()
| Class that provides convenient interface to establish a linkage between custom user application objects and Ogre core classes.
const UserObjectBindings & | getUserObjectBindings () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
bool | hasCustomParameter (size_t index) const
| Checks whether a custom value is associated with this Renderable at the given index.
virtual void | postRender (SceneManager *sm, RenderSystem *rsys)
| Called immediately after the Renderable has been rendered.
void | removeCustomParameter (size_t index)
| Removes a custom value which is associated with this Renderable at the given index.
void | setCustomParameter (size_t index, const Vector4f &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
void | setUserAny (const Any &anything)

## Additional Inherited Members
Static Public Member Functions inherited from Ogre::MovableObject
static uint32 | getDefaultQueryFlags ()
| Get the default query flags for all future MovableObject instances.
static uint32 | getDefaultVisibilityFlags ()
| Get the default visibility flags for all future MovableObject instances.
static void | setDefaultQueryFlags (uint32 flags)
| Set the default query flags for all future MovableObject instances.
static void | setDefaultVisibilityFlags (uint32 flags)
| Set the default visibility flags for all future MovableObject instances.
Static Public Member Functions inherited from Ogre::ShadowCaster
static void | clearShadowRenderableList (ShadowRenderableList &shadowRenderables)
| Common implementation of releasing shadow renderables.
static void | extrudeVertices (const HardwareVertexBufferSharedPtr &vertexBuffer, size_t originalVertexCount, const Vector4 &lightPos, Real extrudeDist)
| Utility method for extruding vertices based on a light.

## Detailed Description

Allows the rendering of a chain of connected billboards.

A billboard chain operates much like a traditional billboard, i.e. its segments always face the camera; the difference being that instead of a set of disconnected quads, the elements in this class are connected together in a chain which must always stay in a continuous strip. This kind of effect is useful for creating effects such as trails, beams, lightning effects, etc.

  A single instance of this class can actually render multiple separate chain segments in a single render operation, provided they all use the same material. To clarify the terminology: a 'segment' is a separate sub-part of the chain with its own start and end (called the 'head' and the 'tail'). An 'element' is a single position / colour / texcoord entry in a segment. You can add items to the head of a chain, and remove them from the tail, very efficiently. Each segment has a max size, and if adding an element to the segment would exceed this size, the tail element is automatically removed and re-used as the new item on the head.

  This class has no auto-updating features to do things like alter the colour of the elements or to automatically add / remove elements over time - you have to do all this yourself as a user of the class. Subclasses can however be used to provide this kind of behaviour automatically.

See also
  RibbonTrail

## Member Enumeration Documentation

## ◆ TexCoordDirection

enum Ogre::BillboardChain::TexCoordDirection

The direction in which texture coordinates from elements of the chain are used.

Enumerator
TCD_U | Tex coord in elements is treated as the 'u' texture coordinate.
TCD_V | Tex coord in elements is treated as the 'v' texture coordinate.

## Constructor & Destructor Documentation

## ◆ BillboardChain()

Ogre::BillboardChain::BillboardChain | ( | const String & | name,
|  | size_t | maxElements = 20,
|  | size_t | numberOfChains = 1,
|  | bool | useTextureCoords = true,
|  | bool | useColours = true,
|  | bool | dynamic = true )

Constructor (don't use directly, use factory).

Parameters

  name | The name to give this object
  maxElements | The maximum number of elements per chain
  numberOfChains | The number of separate chain segments contained in this object
  useTextureCoords | If true, use texture coordinates from the chain elements
  useColours | If true, use vertex colours from the chain elements
  dynamic | If true, buffers are created with the intention of being updated

## ◆ ~BillboardChain()

Ogre::BillboardChain::~BillboardChain | ( |  | ) |

## Member Function Documentation

## ◆ setMaxChainElements()

virtual void Ogre::BillboardChain::setMaxChainElements | ( | size_t | maxElements | ) |
| virtual

Set the maximum number of chain elements per chain.

Reimplemented in Ogre::RibbonTrail.

## ◆ getMaxChainElements()

virtual size_t Ogre::BillboardChain::getMaxChainElements | ( | void |  | ) | const
| inlinevirtual

Get the maximum number of chain elements per chain.

## ◆ setNumberOfChains()

virtual void Ogre::BillboardChain::setNumberOfChains | ( | size_t | numChains | ) |
| virtual

Set the number of chain segments (this class can render multiple chains at once using the same material).

Reimplemented in Ogre::RibbonTrail.

## ◆ getNumberOfChains()

virtual size_t Ogre::BillboardChain::getNumberOfChains | ( | void |  | ) | const
| inlinevirtual

Get the number of chain segments (this class can render multiple chains at once using the same material).

## ◆ setUseTextureCoords()

virtual void Ogre::BillboardChain::setUseTextureCoords | ( | bool | use | ) |
| virtual

Sets whether texture coordinate information should be included in the final buffers generated.

Note
  You must use either texture coordinates or vertex colour since the vertices have no normals and without one of these there is no source of colour for the vertices.

## ◆ getUseTextureCoords()

virtual bool Ogre::BillboardChain::getUseTextureCoords | ( | void |  | ) | const
| inlinevirtual

Gets whether texture coordinate information should be included in the final buffers generated.

## ◆ setTextureCoordDirection()

virtual void Ogre::BillboardChain::setTextureCoordDirection | ( | TexCoordDirection | dir | ) |
| virtual

Sets the direction in which texture coords specified on each element are deemed to run along the length of the chain.

Parameters

  dir | The direction, default is TCD_U.

## ◆ getTextureCoordDirection()

virtual TexCoordDirection Ogre::BillboardChain::getTextureCoordDirection | ( | void |  | ) |
| inlinevirtual

Gets the direction in which texture coords specified on each element are deemed to run.

## ◆ setOtherTextureCoordRange()

virtual void Ogre::BillboardChain::setOtherTextureCoordRange | ( | Real | start,
|  | Real | end )
| virtual

Set the range of the texture coordinates generated across the width of the chain elements.

Parameters

  start | Start coordinate, default 0.0
  end | End coordinate, default 1.0

## ◆ getOtherTextureCoordRange()

virtual const Real * Ogre::BillboardChain::getOtherTextureCoordRange | ( | void |  | ) | const
| inlinevirtual

Get the range of the texture coordinates generated across the width of the chain elements.

## ◆ setUseVertexColours()

virtual void Ogre::BillboardChain::setUseVertexColours | ( | bool | use | ) |
| virtual

Sets whether vertex colour information should be included in the final buffers generated.

Note
  You must use either texture coordinates or vertex colour since the vertices have no normals and without one of these there is no source of colour for the vertices.

## ◆ getUseVertexColours()

virtual bool Ogre::BillboardChain::getUseVertexColours | ( | void |  | ) | const
| inlinevirtual

Gets whether vertex colour information should be included in the final buffers generated.

## ◆ setAutoUpdate()

void Ogre::BillboardChain::setAutoUpdate | ( | bool | autoUpdate | ) |

Set the auto update state.

This methods controls the updating policy of the vertex buffer. By default auto update is true so the vertex buffer is being update every time this billboard set is about to be rendered. This behavior best fit when the billboards of this set changes frequently. When using static or semi-static billboards, it is recommended to set auto update to false. In that case one should call notifyBillboardDataChanged method to reflect changes made to the billboards data.

## ◆ getAutoUpdate()

bool Ogre::BillboardChain::getAutoUpdate | ( | void |  | ) | const
| inline

Return the auto update state.

## ◆ addChainElement()

virtual void Ogre::BillboardChain::addChainElement | ( | size_t | chainIndex,
|  | const Element & | billboardChainElement )
| virtual

Add an element to the 'head' of a chain.

If this causes the number of elements to exceed the maximum elements per chain, the last element in the chain (the 'tail') will be removed to allow the additional element to be added.

Parameters

  chainIndex | The index of the chain
  billboardChainElement | The details to add

## ◆ removeChainElement()

virtual void Ogre::BillboardChain::removeChainElement | ( | size_t | chainIndex | ) |
| virtual

Remove an element from the 'tail' of a chain.

Parameters

  chainIndex | The index of the chain

## ◆ updateChainElement()

virtual void Ogre::BillboardChain::updateChainElement | ( | size_t | chainIndex,
|  | size_t | elementIndex,
|  | const Element & | billboardChainElement )
| virtual

Update the details of an existing chain element.

Parameters

  chainIndex | The index of the chain
  elementIndex | The element index within the chain, measured from the 'head' of the chain
  billboardChainElement | The details to set

## ◆ getChainElement()

virtual const Element & Ogre::BillboardChain::getChainElement | ( | size_t | chainIndex,
|  | size_t | elementIndex ) const
| virtual

Get the detail of a chain element.

Parameters

  chainIndex | The index of the chain
  elementIndex | The element index within the chain, measured from the 'head' of the chain

## ◆ getNumChainElements()

virtual size_t Ogre::BillboardChain::getNumChainElements | ( | size_t | chainIndex | ) | const
| virtual

Returns the number of chain elements.

## ◆ clearChain()

virtual void Ogre::BillboardChain::clearChain | ( | size_t | chainIndex | ) |
| virtual

Remove all elements of a given chain (but leave the chain intact).

Reimplemented in Ogre::RibbonTrail.

## ◆ clearAllChains()

virtual void Ogre::BillboardChain::clearAllChains | ( | void |  | ) |
| virtual

Remove all elements from all chains (but leave the chains themselves intact).

## ◆ setFaceCamera()

void Ogre::BillboardChain::setFaceCamera | ( | bool | faceCamera,
|  | const Vector3 & | normalVector = Vector3::UNIT_X )

Sets whether the billboard should always be facing the camera or a custom direction set by each point element.

Billboards facing the camera are useful for smoke trails, light beams, etc by simulating a cylinder. However, because of this property, wide trails can cause several artefacts unless the head is properly covered. Therefore, non-camera-facing billboards are much more convenient for leaving big trails of movement from thin objects, for example a sword swing as seen in many fighting games.

Parameters

  faceCamera | True to be always facing the camera (Default value: True)
  normalVector | Only used when faceCamera == false. Must be a non-zero vector. This vector is the "point of reference" for each point orientation. For example, if normalVector is Vector3::UNIT_Z, and the point's orientation is an identity matrix, the segment corresponding to that point will be facing towards UNIT_Z This vector is internally normalized.

## ◆ getMaterialName()

virtual const String & Ogre::BillboardChain::getMaterialName | ( | void |  | ) | const
| inlinevirtual

Get the material name in use.

## ◆ setMaterialName()

virtual void Ogre::BillboardChain::setMaterialName | ( | const String & | name,
|  | const String & | groupName = ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME )
| virtual

Set the material name to use for rendering.

References Ogre::ResourceGroupManager::AUTODETECT_RESOURCE_GROUP_NAME.

## ◆ getSquaredViewDepth()

Real Ogre::BillboardChain::getSquaredViewDepth | ( | const Camera * | cam | ) | const
| overridevirtual

Returns the squared distance between the camera and this renderable.

Used to sort transparent objects. Squared distance is used to avoid having to perform a square root on the result.

Implements Ogre::Renderable.

## ◆ getBoundingRadius()

Real Ogre::BillboardChain::getBoundingRadius | ( | void |  | ) | const
| overridevirtual

Retrieves the radius of the origin-centered bounding sphere for this object.

Implements Ogre::MovableObject.

## ◆ getBoundingBox()

const AxisAlignedBox & Ogre::BillboardChain::getBoundingBox | ( | void |  | ) | const
| overridevirtual

Retrieves the local axis-aligned bounding box for this object.

This bounding box is in local coordinates.

Implements Ogre::MovableObject.

## ◆ getMaterial()

const MaterialPtr & Ogre::BillboardChain::getMaterial | ( | void |  | ) | const
| overridevirtual

Retrieves a weak reference to the material this renderable object uses.

Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.

Implements Ogre::Renderable.

## ◆ getMovableType()

const String & Ogre::BillboardChain::getMovableType | ( | void |  | ) | const
| overridevirtual

Returns the type name of this object.

Implements Ogre::MovableObject.

Reimplemented in Ogre::RibbonTrail.

## ◆ _updateRenderQueue()

void Ogre::BillboardChain::_updateRenderQueue | ( | RenderQueue * | queue | ) |
| overridevirtual

Internal method by which the movable object must add Renderable subclass instances to the rendering queue.

The engine will call this method when this object is to be rendered. The object must then create one or more Renderable subclass instances which it places on the passed in Queue for rendering.

Implements Ogre::MovableObject.

## ◆ getRenderOperation()

void Ogre::BillboardChain::getRenderOperation | ( | RenderOperation & | op | ) |
| overridevirtual

Gets the render operation required to send this object to the frame buffer.

Implements Ogre::Renderable.

## ◆ preRender()

bool Ogre::BillboardChain::preRender | ( | SceneManager * | sm,
|  | RenderSystem * | rsys )
| overridevirtual

Called just prior to the Renderable being rendered.

OGRE is a queued renderer, so the actual render commands are executed at a later time than the point at which an object is discovered to be visible. This allows ordering & grouping of renders without the discovery process having to be aware of it. It also means OGRE uses declarative render information rather than immediate mode rendering - this is very useful in that certain effects and processes can automatically be applied to a wide range of scenes, but the downside is that special cases are more difficult to handle, because there is not the declared state to cope with it.

  This method allows a Renderable to do something special at the actual point of rendering if it wishes to. When this method is called, all the material render state as declared by this Renderable has already been set, all that is left to do is to bind the buffers and perform the render. The Renderable may modify render state itself if it wants to (and restore it in the postRender call) before the automated render happens, or by returning 'false' from this method can actually suppress the automatic render and perform one of its own.

Returns
  true if the automatic render should proceed, false to skip it on the assumption that the Renderable has done it manually.

Reimplemented from Ogre::Renderable.

## ◆ getWorldTransforms()

void Ogre::BillboardChain::getWorldTransforms | ( | Matrix4 * | xform | ) | const
| overridevirtual

Gets the world transform matrix / matrices for this renderable object.

If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called.

Note
  Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here.

This method will populate transform with 1 matrix if it does not use GPU vertex blending. If it does use GPU vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms.

Note
  If MeshManager::getBonesUseObjectSpace() is true, the first matrix must contain the world transform of the object, and the rest of the matrices must contain the bone transforms in object space.

Implements Ogre::Renderable.

## ◆ getLights()

const LightList & Ogre::BillboardChain::getLights | ( | void |  | ) | const
| overridevirtual

Gets a list of lights, ordered relative to how close they are to this renderable.

Directional lights, which have no position, will always be first on this list.

Implements Ogre::Renderable.

## ◆ visitRenderables()

void Ogre::BillboardChain::visitRenderables | ( | Renderable::Visitor * | visitor,
|  | bool | debugRenderables = false )
| overridevirtual

Method to allow a caller to abstractly iterate over the Renderable instances that this MovableObject will add to the render queue when asked, if any.

Parameters

  visitor | Pointer to a class implementing the Renderable::Visitor interface which will be called back for each Renderable which will be queued. Bear in mind that the state of the Renderable instances may not be finalised depending on when you call this.
  debugRenderables | If false, only regular renderables will be visited (those for normal display). If true, debug renderables will be included too.

Implements Ogre::MovableObject.

The documentation for this class was generated from the following file:

- OgreBillboardChain.h